LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;

LIBRARY work;
USE work.YOLO_pkg.ALL;

ENTITY L5_BNROM IS
    PORT (
        clk : IN STD_LOGIC;
        coefs : OUT STD_LOGIC_VECTOR(63 DOWNTO 0); -- Instruction bus
        address : IN unsigned(6 DOWNTO 0));
END L5_BNROM;

ARCHITECTURE RTL OF L5_BNROM IS

    TYPE ROM_mem IS ARRAY (0 TO 127) OF STD_LOGIC_VECTOR(63 DOWNTO 0);

    --kernel2(bias&scale) & kernel1(bias&scale)

    signal ROM_content : ROM_mem :=
    (    0=>"1111111000000111"&"0000001001110010"&"0000001100110110"&"0000001100000011",
    1=>"1111111100110111"&"0000001100000101"&"1111111101000111"&"0000001110001011",
    2=>"0000000011110010"&"0000001011010011"&"1111111000011101"&"0000001011001011",
    3=>"0000000010010101"&"0000001001111100"&"0000001100111110"&"0000001011100001",
    4=>"0000000000100010"&"0000001101001001"&"1111111011111010"&"0000001011110101",
    5=>"1111111101100101"&"0000001010100100"&"0000000000000110"&"0000001011000100",
    6=>"1111111111001101"&"0000001010111001"&"1111101110101000"&"0000001110100001",
    7=>"1111110111011010"&"0000001101110011"&"1111111111110011"&"0000001001111011",
    8=>"1111110100100010"&"0000001100001011"&"0000001010001011"&"0000001011111111",
    9=>"1111111111100010"&"0000001100000110"&"1111110111001100"&"0000001011111100",
    10=>"1111111001100110"&"0000001011001111"&"1111110001111110"&"0000001010011111",
    11=>"1111111101011111"&"0000001001110101"&"1111111000100000"&"0000001001110000",
    12=>"1111111010100011"&"0000001101000111"&"1111101110011110"&"0000001100100001",
    13=>"0000000101100001"&"0000001001100001"&"0000001000101000"&"0000000111111100",
    14=>"1111110011110100"&"0000001101011100"&"1111111000010101"&"0000001010100110",
    15=>"1111110111101010"&"0000001010111100"&"1111111011011110"&"0000001111000011",
    16=>"1111010100111110"&"0000001110001111"&"1111111101101000"&"0000001101001010",
    17=>"0000000100111000"&"0000001101011011"&"1111111010000001"&"0000001100100011",
    18=>"1111111101100111"&"0000001010111000"&"1111111011010001"&"0000001001101011",
    19=>"1111111011001111"&"0000001011000011"&"1111111001011010"&"0000001101001100",
    20=>"1111110010001110"&"0000001100011010"&"1111110111010010"&"0000001010110011",
    21=>"1111110110010011"&"0000001101100101"&"0000001011011000"&"0000001011011111",
    22=>"0000000101110100"&"0000001001010101"&"1111111101001111"&"0000001000110010",
    23=>"0000000111110101"&"0000001000011101"&"0000000001110101"&"0000001010010000",
    24=>"1111111101010101"&"0000001100001001"&"0000000111000011"&"0000001001011111",
    25=>"1111111101111010"&"0000001010010001"&"1111100101100011"&"0000001101010000",
    26=>"0000000000010000"&"0000001110110011"&"1111111101011001"&"0000001011000001",
    27=>"0000000110110011"&"0000000111011011"&"1111110100100111"&"0000001101100101",
    28=>"1111111010000001"&"0000001011100111"&"1111111010100011"&"0000000111111111",
    29=>"1111111110111011"&"0000001011001101"&"1111110001001011"&"0000001110011100",
    30=>"1111110100001100"&"0000001011001011"&"1111111101011111"&"0000001010011011",
    31=>"1111111101010010"&"0000001011010110"&"1111110110011111"&"0000001110001011",
    32=>"1111100110111010"&"0000001010110000"&"0000001100001101"&"0000000111111100",
    33=>"1111111011010110"&"0000001111010010"&"1111110111011100"&"0000001001001010",
    34=>"0000000010011010"&"0000001010001000"&"1111110011011010"&"0000001011000100",
    35=>"0000000010001010"&"0000001001010101"&"0000000001101111"&"0000010001101000",
    36=>"1111110011100110"&"0000001111110011"&"0000000101100100"&"0000001011101111",
    37=>"0000000101000110"&"0000001011100110"&"0000000000100011"&"0000001010111001",
    38=>"0000000001011010"&"0000001010011010"&"1111110100101010"&"0000001110000101",
    39=>"1111111110010011"&"0000001110010111"&"0000001101001101"&"0000001000001010",
    40=>"0000000011001111"&"0000001010001101"&"1111111100011100"&"0000001100110110",
    41=>"1111111111001111"&"0000001011000100"&"0000001111101101"&"0000001001111101",
    42=>"0000000001001010"&"0000001101011010"&"0000000010100010"&"0000001011101100",
    43=>"0000000010001111"&"0000001010010100"&"1111110001011111"&"0000001010000001",
    44=>"1111101110001111"&"0000001010001000"&"1111111000100110"&"0000001100101010",
    45=>"1111111101100011"&"0000010001101111"&"1111111011100010"&"0000001101011101",
    46=>"0000000001100011"&"0000001100010110"&"0000000001010000"&"0000001011100101",
    47=>"0000000100111010"&"0000001010010110"&"1111111000111101"&"0000001101011001",
    48=>"0000000111101010"&"0000001001011110"&"0000000100011100"&"0000001010010000",
    49=>"1111110111110100"&"0000010001111010"&"1111111110101010"&"0000001010010000",
    50=>"1111111011111001"&"0000001101110011"&"1111111101011001"&"0000001010100001",
    51=>"1111111001000111"&"0000001010010100"&"1111111101001011"&"0000001110100010",
    52=>"1111111010111111"&"0000001100010111"&"1111111100101001"&"0000001010110000",
    53=>"0000000001011010"&"0000001011101100"&"1111110101011101"&"0000001010000100",
    54=>"1111110101111101"&"0000001011100110"&"1111111011101011"&"0000001001110011",
    55=>"1111110111001010"&"0000001101111000"&"0000000001110110"&"0000001000011101",
    56=>"0000000010110011"&"0000001101011101"&"1111111101100100"&"0000001000111010",
    57=>"1111110111010000"&"0000001101011011"&"1111111111000111"&"0000001010001001",
    58=>"1111111000010110"&"0000001101101111"&"1111111010001100"&"0000001000000001",
    59=>"1111111100000001"&"0000001100010000"&"1111110100110000"&"0000001100010101",
    60=>"0000000011001000"&"0000001100000000"&"1111111011010100"&"0000001010101011",
    61=>"0000000000010010"&"0000001100011110"&"1111111001000101"&"0000001110011100",
    62=>"0000000111010000"&"0000001011011100"&"1111111000101011"&"0000001100101101",
    63=>"1111111101101100"&"0000001110100001"&"1111010010001101"&"0000001000110100",
    64=>"1111111010010011"&"0000001010001101"&"1111111001010011"&"0000001110010011",
    65=>"1111111100001000"&"0000001000101000"&"0000000100010101"&"0000001011011010",
    66=>"1111110010011000"&"0000000111101101"&"1111110111000111"&"0000001101100110",
    67=>"1111111000001000"&"0000001101110000"&"1111111011100100"&"0000001100001010",
    68=>"1111111110010001"&"0000001111000100"&"1111111000001001"&"0000001110100111",
    69=>"0000000110001010"&"0000001010101110"&"1111111111010001"&"0000001010101001",
    70=>"1111110111110010"&"0000001111100010"&"1111111101010100"&"0000001110111111",
    71=>"0000000011111111"&"0000001001101110"&"1111110001011110"&"0000001011111010",
    72=>"1111111111101011"&"0000001011100111"&"1111110101110100"&"0000010000001110",
    73=>"1111110010111111"&"0000010000011101"&"1111111010100110"&"0000001010111011",
    74=>"0000000010101001"&"0000001100001101"&"1111100001000110"&"0000001011111111",
    75=>"1111111111011010"&"0000001101001110"&"1111111101011101"&"0000001101011101",
    76=>"0000000111110011"&"0000001001000001"&"1111101011111111"&"0000001101000000",
    77=>"1111111001100001"&"0000001001001011"&"1111111011010001"&"0000001001110010",
    78=>"1111110100111010"&"0000001101101111"&"1111111110011100"&"0000001010100110",
    79=>"1111110011100111"&"0000001010100000"&"0000000001000111"&"0000001010110111",
    80=>"1111111110001011"&"0000001011001100"&"1111111001100010"&"0000001101011010",
    81=>"0000001001111001"&"0000000111111010"&"1111111110010001"&"0000001001010110",
    82=>"0000000101111000"&"0000001011011111"&"0000000010011011"&"0000001100010111",
    83=>"0000000000010100"&"0000001011101001"&"0000000110101111"&"0000001010110001",
    84=>"0000000011101111"&"0000001010010110"&"1111111010101011"&"0000001011101100",
    85=>"0000000010101100"&"0000001000110010"&"1111111100001110"&"0000001010110111",
    86=>"1111111111001010"&"0000001100011110"&"1111111010111000"&"0000001100001000",
    87=>"0000001001100100"&"0000000111011010"&"1111111111110011"&"0000001011110101",
    88=>"1111111110010100"&"0000001100011010"&"0000001110010000"&"0000001101011100",
    89=>"0000001000110010"&"0000000110000101"&"0000000001000011"&"0000001011111111",
    90=>"0000000010101100"&"0000001001101000"&"1111111111010110"&"0000001011100111",
    91=>"1111110001101000"&"0000010011001110"&"1111111110001111"&"0000001001111011",
    92=>"1111111111111010"&"0000001001000011"&"1111111001001000"&"0000001011001111",
    93=>"0000000011111100"&"0000001010110111"&"1111111100110111"&"0000000111010101",
    94=>"0000000011110010"&"0000001101010110"&"1111111110111010"&"0000001010111110",
    95=>"1111111011111000"&"0000001011001111"&"0000001111010100"&"0000000111000011",
    96=>"1111111111100010"&"0000001010101100"&"1111110111010011"&"0000001110100100",
    97=>"1111111100111100"&"0000001001111001"&"1111110000001100"&"0000001100101110",
    98=>"0000000111111001"&"0000001010101011"&"1111110010101010"&"0000001011100010",
    99=>"0000001011011111"&"0000001001001110"&"0000000001100001"&"0000001010100100",
    100=>"0000000101111010"&"0000001100101010"&"1111111111010000"&"0000001011110000",
    101=>"1111101111101001"&"0000001010000001"&"1111111001100000"&"0000001010110010",
    102=>"0000000111110000"&"0000001000111111"&"0000000011010100"&"0000001100100001",
    103=>"1111111110111110"&"0000001001001000"&"1111111000101010"&"0000001101011001",
    104=>"0000000000010000"&"0000001010010011"&"0000000000100111"&"0000001001011111",
    105=>"1111111010000100"&"0000001011001000"&"0000000000001111"&"0000001010011011",
    106=>"1111111101101110"&"0000001100111000"&"1111111111101001"&"0000001001111100",
    107=>"1111111100001001"&"0000001001110101"&"0000000011111011"&"0000001010010110",
    108=>"0000000001000011"&"0000001100110100"&"1111111101110000"&"0000001011010001",
    109=>"0000001001111001"&"0000001000101010"&"0000000111010110"&"0000001010111110",
    110=>"0000000001111110"&"0000001100101001"&"0000001011100110"&"0000001000000100",
    111=>"0000000011010001"&"0000001011110100"&"1111111010100110"&"0000001000110100",
    112=>"1111101110000111"&"0000001100110100"&"1111110011010100"&"0000001011011110",
    113=>"0000000010010101"&"0000001000010010"&"0000000001011110"&"0000001011001011",
    114=>"1111111000010111"&"0000001110100101"&"1111111101000011"&"0000001001111101",
    115=>"0000000011000111"&"0000001011011100"&"0000000000110000"&"0000001000100011",
    116=>"1111111110100110"&"0000001001101110"&"0000001100000010"&"0000001010100011",
    117=>"1111111101010100"&"0000001100011010"&"0000000110100001"&"0000001001000100",
    118=>"0000001011111101"&"0000001001000001"&"1111011011010101"&"0000001100111000",
    119=>"1111101001101110"&"0000001100110100"&"1111111000111110"&"0000001011100001",
    120=>"1111110100001101"&"0000001011001101"&"0000000010100100"&"0000001011110100",
    121=>"0000000101001101"&"0000000111100010"&"1111111111000111"&"0000001100100100",
    122=>"1111111110010110"&"0000001010110010"&"0000000011110001"&"0000001001100100",
    123=>"0000000000010100"&"0000000111100011"&"1111111100010010"&"0000001011010101",
    124=>"0000000100110101"&"0000001100011100"&"1111111110101001"&"0000001010000110",
    125=>"1111111110010001"&"0000001000000111"&"1111110101000001"&"0000001110000011",
    126=>"1111111101110100"&"0000001000011110"&"1111111110001101"&"0000001100010011",
    127=>"1111111101100000"&"0000001011110111"&"0000000000101001"&"0000001001110011"

    );

    attribute rom_style : string; 
    attribute rom_style of ROM_content : signal is "block";
BEGIN
proc_name : PROCESS (clk)
BEGIN
  IF rising_edge(clk) THEN
    coefs <= ROM_content(to_integer(address));
  END IF;
END PROCESS proc_name;END RTL;